
    !- cCGI method definition file
    MEMBER()
    MAP
        !- CGI API calls
        MODULE('win32.lib')
            GetStdHandle(ULONG),UNSIGNED,PASCAL,NAME('GetStdHandle')
            ReadFile(UNSIGNED,*CSTRING,ULONG,*ULONG,<*OVERLAPPED>),BOOL,PASCAL,RAW,NAME('ReadFile')
            WriteFile(UNSIGNED,*CSTRING,ULONG,*ULONG,<*OVERLAPPED>),BOOL,PASCAL,RAW,NAME('WriteFile')
            GetEnvironmentVar(*CSTRING,*CSTRING,ULONG),ULONG,PASCAL,RAW,NAME('GetEnvironmentVariableA')
            SetFilePointer(UNSIGNED,LONG,LONG,ULONG),ULONG,PASCAL,NAME('SetFilePointer')
            SetEndOfFile(UNSIGNED),BOOL,PASCAL,NAME('SetEndOfFile')
        END
    END
    INCLUDE('cCGI.inc')

                                !- CGI Global Template Data

    ITEMIZE(-1)                  !- Object Equates
_Default    EQUATE
_Center     EQUATE
_Left       EQUATE
_Right      EQUATE
    END

FILE_BEGIN          ULONG(0)
STD_INPUT_HANDLE    EQUATE(-10)
STD_OUTPUT_HANDLE   EQUATE(-11)

!- For WriteFile() API
OVERLAPPED          GROUP,TYPE
Internal            ULONG
InternalHigh        ULONG
Offset              ULONG
OffsetHigh          ULONG
hEvent              UNSIGNED
    END

!- WriteFile() vars
lBytesWritten       ULONG
OVERLAPPED_         LIKE(OVERLAPPED)
ZeroPointer         LONG(0)
ZERO_DIST_TO_MOVE   LONG(0)


cCGI.Init           PROCEDURE
EnvVarName      CSTRING(20)     !- Environment variable name
ContentLength   ULONG           !- Length of POSTed data
BytesRead       ULONG           !- Bytes of POSTed data read
VarLen          EQUATE(129)
    CODE
    SELF.TupleQ &= NEW(TupleQType)
    SELF.hStdIn = GetStdHandle(STD_INPUT_HANDLE)                            !- I/O parms
    SELF.hStdOut = GetStdHandle(STD_OUTPUT_HANDLE)                          !- I/O parms
    SELF.HTMLOut('Content-type: text/html<10>')                             !- Let the server know we are alive
    EnvVarName = 'REQUEST_METHOD'
    junk# = GetEnvironmentVar(EnvVarName,SELF.CGI_RequestMethod,VarLen)
    EnvVarName = 'QUERY_STRING'
    junk# = GetEnvironmentVar(EnvVarName,SELF.CGI_QueryString,VarLen)
    CASE CLIP(SELF.CGI_RequestMethod)
        OF 'POST'
            !- Load all POSTed data
            EnvVarName = 'CONTENT_LENGTH'
            junk# = GetEnvironmentVar(EnvVarName,SELF.CGI_ContentLength,VarLen)
            ContentLength = SELF.CGI_ContentLength         !- Convert to number
            IF ContentLength
                junk# = ReadFile(SELF.hStdIn,SELF.CGI_FormData,ContentLength,BytesRead,OVERLAPPED_)
                SELF.GetAllCGI
            END
    END!CASE
    !junk# = SetFilePointer(SELF.hStdOut,ZERO_DIST_TO_MOVE,ZeroPointer,FILE_BEGIN)
    SELF.HeaderOut                                                          !- Begin the page

cCGI.GetAllCGI          PROCEDURE
LastAmpersand   LONG,AUTO
LastEqual       LONG,AUTO
    CODE
    LastAmpersand = 1
    LastEqual = 0
    !- Loads all POST data into Tuple Q
    FREE(SELF.TupleQ)
    LOOP
        LastEqual = INSTRING('=',CLIP(SELF.CGI_FormData),1,LastAmpersand)
        IF NOT LastEqual
            BREAK
        END
        IF LastAmpersand = 1
            LastAmpersand = 0
        END
        SELF.TupleQ.Key = SELF.CGI_FormData[(LastAmpersand+1):(LastEqual-1)]
        LastAmpersand = INSTRING('&',CLIP(SELF.CGI_FormData),1,LastEqual)
        IF NOT LastAmpersand
            SELF.TupleQ.Value = SELF.CGI_FormData[(LastEqual+1):LEN(CLIP(SELF.CGI_FormData))]
            ADD(SELF.TupleQ)
            BREAK
        END
        SELF.TupleQ.Value = SELF.CGI_FormData[(LastEqual+1):(LastAmpersand-1)]
        ADD(SELF.TupleQ)
    END!LOOP

cCGI.GetValue           FUNCTION(STRING MyValue)
    CODE
    !- Find a value in the global queue and return it
    SORT(SELF.TupleQ, +SELF.TupleQ.Key)
    SELF.TupleQ.Key = CLIP(MyValue)
    GET(SELF.TupleQ, SELF.TupleQ.Key)
    IF ERRORCODE()
        RETURN('')
    ELSE
        RETURN(SELF.TupleQ.Value)
    END

cCGI.HTMLOut            PROCEDURE(MyOut)                                !- Output a line to the HTML file
MyCString       CSTRING(255),AUTO
FILE_END        EQUATE(2)
    CODE
        MyCString = MyOut
        MyCString = CLIP(MyCString) & '<10>'


        !- PWS for Win95 code, does not work yet
        !junk# = WriteFile(SELF.hStdOut,MyCString,LEN(MyCString),lBytesWritten)

        !- Original WinNT code
        junk# = WriteFile(SELF.hStdOut,MyCString,LEN(MyCString),lBytesWritten,OVERLAPPED_)

cCGI.ErrorOut           PROCEDURE(<STRING MyError>)                       !- Abandon everything and report error
TheError    STRING(255)
TheErrorCode    LONG
StdOut  LONG
    CODE
    !- Reset the WriteFile() pointer to start over and report the error
    StdOut = SELF.hStdOut
    !junk# = SetFilePointer(SELF.hStdOut,ZERO_DIST_TO_MOVE,ZeroPointer,FILE_BEGIN)
    !junk# = SetFilePointer(StdOut,ZERO_DIST_TO_MOVE,ZeroPointer,FILE_BEGIN)
    TheError = ERROR()
    TheErrorCode = ERRORCODE()
    !SELF.HTMLOut('Content-type: text/html')
    !SELF.HTMLOut('')
    !SELF.HTMLOut('<<HTML><<HEAD>')
    !SELF.HTMLOut('<</HEAD><<BODY>')
    SELF.HTMLOut('<<h1>Error - ' & SELF.GetValue('Executable Path') & '<</h1>')
    SELF.HTMLOut('<<PRE>' & CLIP(TheErrorCode) & ' - ' & CLIP(TheError))
    IF CLIP(MyError)
        SELF.HTMLOut(CLIP(MyError))
    END
    SELF.HTMLOut('<</PRE>Date: ' & FORMAT(TODAY(), @d2) & '  Time: ' & FORMAT(CLOCK(),@t4))
    !SELF.HTMLOut('<</BODY><</HTML>')
    junk# = SetEndOfFile(SELF.HStdOut)
    HALT                                                                   !- Terminate the program


cCGI.TableHeader        PROCEDURE(STRING MyHeader)                      !- Output HTML table header
HeaderQ QUEUE, PRE(HQ)
Head        STRING(40)
    END
    CODE
    FREE(HeaderQ)
        !- Find header item
        CurrentChar# = 0
        LastChar# = 1
        LOOP
            Currentchar# += 1
            IF CurrentChar# >= LEN(CLIP(MyHeader)) THEN BREAK.
            IF SUB(CLIP(MyHeader), CurrentChar#, 1) = '|'
                HQ:Head = MyHeader[LastChar#:(CurrentChar#-1)]
                ADD(HeaderQ)
                LastChar# = (CurrentChar#+1)
            END
        END!LOOP
        HQ:Head =  MyHeader[LastChar#:CurrentChar#] !- Last header...
        ADD(HeaderQ)
        !- Output HTML
        !- Netscape Table Header
        IF SELF.TableCenter
            SELF.HTMLOut('<<i><<CENTER><<TABLE BORDER='&SELF.TableBorder& ' WIDTH=' &SELF.TableWidth& '%%><<tr>')
        ELSE
            SELF.HTMLOut('<<i><<TABLE BORDER=' &SELF.TableBorder& ' WIDTH=' &SELF.TableWidth&'%%><<tr>')
        END
        LOOP CurrentHeader# = 1 to RECORDS(HeaderQ)
            GET(HeaderQ, CurrentHeader#)
            SELF.HTMLOut('<<th>'&CLIP(HQ:Head)&'<</th>')
        END!LOOP
        SELF.HTMLOut('<</tr><</i>')

cCGI.TableItem          PROCEDURE(STRING MyItems)                           !- Output table row
ItemQ   QUEUE, PRE(IQ)
Item        STRING(255)
    END
    CODE
    FREE(ItemQ)
    !- Find header item
    CurrentChar# = 0
    LastChar# = 1
        LOOP
            Currentchar# += 1
            IF CurrentChar# >= LEN(CLIP(MyItems)) THEN BREAK.
            IF SUB(CLIP(MyItems), CurrentChar#, 1) = '|'
                IQ:Item = MyItems[LastChar#:(CurrentChar#-1)]
                ADD(ItemQ)
                LastChar# = (CurrentChar#+1)
            END
        END!LOOP
        IQ:Item =  MyItems[LastChar#:CurrentChar#]  !- Last item...
        ADD(ItemQ)
    IF SELF.TableRowAlign = _Left
        Align" = '<<p align=left>'
    ELSIF SELF.TableRowAlign = _Right
        Align" = '<<p align=right>'
    ELSIF SELF.TableRowAlign = _Center
        Align" = '<<p align=center>'
    ELSE
        Align" = ''
    END
    SELF.HTMLOut('<<tr BORDER=' &SELF.TableBorder& '>')
    LOOP CurrentItem# = 1 TO RECORDS(ItemQ)
        GET(ItemQ, CurrentItem#)
        SELF.HTMLOut('<<td>'&Align"&CLIP(IQ:Item)&'<</td>')
    END!LOOP
    SELF.HTMLOut('<</tr>')

cCGI.TableFooter        PROCEDURE                                           !- Output table end
    CODE
    IF SELF.TableCenter
        SELF.HTMLOut('<</TABLE><</CENTER><<p>')
    ELSE
        SELF.HTMLOut('<</TABLE><<p>')
    END

cCGI.TableSet           PROCEDURE(BYTE Center, BYTE Border, BYTE RowAlign, BYTE Width) !- Reset table settings
    CODE
    IF Center = _DEFAULT
        SELF.TableCenter = SELF._DefTableCenter
    ELSE
        SELF.TableCenter = Center
    END
    IF Border = _DEFAULT
         SELF.TableBorder = SELF._DefTableBorder
    ELSE
        SELF.TableBorder = Border
    END
    IF RowAlign = _DEFAULT
         SELF.TableRowAlign = SELF._DefTableRowAlign
    ELSE
        SELF.TableRowAlign = RowAlign
    END
    IF Width = _DEFAULT
         SELF.TableWidth = SELF._DefTableWidth
    ELSE
        SELF.TableWidth = Width
    END

cCGI.Kill               PROCEDURE
    CODE
    SELF.FooterOut()
    DISPOSE(SELF.TupleQ)

cCGI.HeaderOut          PROCEDURE                                           !- Virtual procedure
    CODE
    SELF.HTMLOut('<<HTML><<HEAD>')                                          !- Generate Default HTML

cCGI.FooterOut          PROCEDURE                                           !- Virtual procedure
    CODE
    SELF.HTMLOut('<</BODY><</HTML>')